<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="model"
            :hidden-data="{
                id: formModel.id,
            }"
            :fields="formFields"
        />
        <div
            v-if="model && parseInt(model.status) === 0"
            class="flex justify-end space-x-2"
        >
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, inject, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $helper = inject('$helper');
const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref({});

const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'user_username',
            label: $i18n.t('user'),
            readonly: true,
            disabled: true
        },
        {
            type: 'text',
            name: 'from_crypto_symbol',
            label: $i18n.t('crypto'),
            readonly: true,
            disabled: true
        },
        {
            type: 'text',
            name: 'to_crypto_address',
            label: $i18n.t('to_crypto_address'),
            readonly: true,
            disabled: true,
            copy: true,
        },
        {
            type: 'text',
            name: 'topup_amount',
            label: $i18n.t('amount'),
            readonly: true,
            disabled: true
        },
        {
            type: 'file',
            name: 'receipt',
            label: $i18n.t('receipt'),
            readonly: true,
            disabled: true,
            previewImage: model.value.receipt,
        },
        {
            type: 'select',
            name: 'status',
            options: [
                {text: $i18n.t('pending'), value: '0'},
                {text: $i18n.t('completed'), value: '1'},
                {text: $i18n.t('canceled'), value: '2'},
            ],
            label: $i18n.t('status'),
            readonly: parseInt(model.value.status) !== 0,
            disabled: parseInt(model.value.status) !== 0
        },
        {
            type: 'text',
            name: 'transaction_id',
            label: $i18n.t('transaction_hash'),
            readonly: true,
            disabled: true
        },
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/user/topup/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/user/topup/build_form', {
            id: props.formModel.id,
        });

        model.value.user_username = data.model.user.username || '-';
        model.value.from_crypto_symbol = data.model.from_crypto_symbol || '-';
        model.value.to_crypto_address = data.model.to_crypto_address || '-';
        model.value.topup_amount = $helper.fundFormat(data.model.topup_amount, 2) || '-';
        model.value.receipt = String(data.model.receipt);
        model.value.status = String(data.model.status);
        model.value.transaction_id = String(data.model.transaction_id || '');

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
